
package knapsack;

/**
 * Evolvable knapsack load plan.
 *
 * @author	Copyright (C) 2002 Alessandro Bollini
 */
public class Plan {

	private final boolean[] genotype;
	private final Knapsack phenotype;
	private final double fitness;


	public Plan(
		final boolean[] genotype,
		final Knapsack phenotype, final double fitness) {

		if ( genotype == null ) {
			throw new IllegalArgumentException("null genotype");
		}

		if ( phenotype == null ) {
			throw new IllegalArgumentException("null phenotype");
		}

		if ( fitness < 0.0 ) {
			throw new IllegalArgumentException("negative fitness");
		}

		this.genotype=genotype;
		this.phenotype=phenotype;
		this.fitness=fitness;
	}


	public boolean[] getGenotype() {
		return genotype;
	}

	public Knapsack getPhenotype() {
		return phenotype;
	}

	public double getFitness() {
		return fitness;
	}
}
