
package regression;

/**
 * Evolvable symbolic regression.
 *
 * @author	Copyright (C) 2002 Alessandro Bollini
 */
public class Regression {

	private final byte[] genotype;
	private final Function phenotype;
	private final double fitness; // standardized [0..[


	public Regression(
		final byte[] genotype,
		final Function phenotype, final double fitness) {

		if ( genotype == null ) {
			throw new IllegalArgumentException("null genotype");
		}

		if ( phenotype == null ) {
			throw new IllegalArgumentException("null phenotype");
		}

		if ( fitness < 0.0 ) {
			throw new IllegalArgumentException("negative fitness");
		}

		this.genotype=genotype;
		this.phenotype=phenotype;
		this.fitness=fitness;
	}


	public byte[] getGenotype() {
		return genotype;
	}

	public Function getPhenotype() {
		return phenotype;
	}

	public double getFitness() {
		return fitness;
	}
}
